#include "DColorBrush.h"

using namespace DWriteWarpper;

DColorBrush::DColorBrush(ID2D1SolidColorBrush* brush)
{
	if(brush == NULL)
		throw gcnew ArgumentNullException("brush is NULL");
	brush_ = brush;
	disposed = false;
}

ID2D1SolidColorBrush* DColorBrush::brush::get() { return this->brush_; }

Color2F DColorBrush::Color::get()
{
	D2D1_COLOR_F color = this->brush_->GetColor();
	return Color2F(color.r,color.b,color.b,color.a);
}


DColorBrush::~DColorBrush()
{
	GC::SuppressFinalize(this);
	this->!DColorBrush();
}

DColorBrush::!DColorBrush()
{
	if(disposed)
		return;
	int cRefCount = brush_->Release();
	disposed = true;
}
